
DO
$$
declare
	c1 cursor for (SELECT customer_id FROM customer WHERE sales_rep_id IS null);
	c2 cursor for (SELECT employee_id FROM employee EXCEPT SELECT employee_id FROM employee_department);
	c3 cursor for SELECT product_id FROM product WHERE department_id IS NULL;
	rec record;
	dep_id varchar(25);
begin
	open c1;
	loop
		fetch next from c1 into rec;
		exit when not found;
		update customer set sales_rep_id = (SELECT employee_id FROM employee ORDER BY RANDOM() LIMIT 1)
		 where current of c1;
	end loop;
	close c1;


	open c2;
	loop
		fetch next from c2 into rec;
		exit when not found;
		dep_id := (SELECT department_id FROM department ORDER BY RANDOM() LIMIT 1);
		exit when dep_id is null;
		insert into employee_department (employee_id, department_id, employee_role)
		values (rec.employee_id, dep_id, cast(random() as varchar));
	end loop;
	close c2;

	open c3;
	loop
		fetch next from c3 into rec;
		exit when not found;
		update product set department_id = (SELECT department_id FROM department ORDER BY RANDOM() LIMIT 1)
		 where current of c3;
	end loop;
	close c3;
end;
$$;