
-- Set any missing service reps
BEGIN
	declare @customer_id varchar(25)

	declare cust_cursor CURSOR FOR
	SELECT customer_id FROM customer
	WHERE sales_rep_id IS NULL

	OPEN cust_cursor
	FETCH NEXT FROM cust_cursor INTO @customer_id

	WHILE @@FETCH_STATUS = 0
	BEGIN
		UPDATE customer SET sales_rep_id = (SELECT TOP 1 employee_id FROM employee ORDER BY NEWID())
		 WHERE customer_id = @customer_id

		FETCH NEXT FROM cust_cursor INTO @customer_id
	END

	CLOSE cust_cursor
	DEALLOCATE cust_cursor
END

GO

-- Add employee departments
BEGIN
	declare @employee_id varchar(25)
	declare @department_id varchar(25)

	declare employee_cursor CURSOR FOR
	SELECT employee_id FROM employee
	MINUS
	SELECT employee_id FROM employee_department

	OPEN employee_cursor
	FETCH NEXT FROM employee_cursor INTO @employee_id

	WHILE @@FETCH_STATUS = 0
	BEGIN
		SELECT TOP 1 @department_id = department_id FROM department ORDER BY NEWID()

		INSERT INTO employee_department (employee_id, department_id, employee_role)
		VALUES (@employee_id, @department_id, CONVERT(varchar(255), NEWID()))

		FETCH NEXT FROM employee_cursor INTO @employee_id
	END

	CLOSE employee_cursor
	DEALLOCATE employee_cursor
END

GO

-- Set any missing product department values
BEGIN
	declare @product_id varchar(25)

	declare product_cursor CURSOR FOR
	SELECT product_id FROM product
	WHERE department_id IS NULL

	OPEN product_cursor
	FETCH NEXT FROM product_cursor INTO @product_id

	WHILE @@FETCH_STATUS = 0
	BEGIN
		UPDATE product SET department_id = (SELECT TOP 1 department_id FROM department ORDER BY NEWID())
		 WHERE product_id = @product_id

		FETCH NEXT FROM product_cursor INTO @product_id
	END

	CLOSE product_cursor
	DEALLOCATE product_cursor
END

GO
